<?php

add_action( 'admin_menu', 'mtfgf_tooltip_generator_add_admin_menu' );
add_action( 'admin_init', 'mtfgf_tooltip_generator_init' );


$GLOBALS['mtfgf_css_generator_options_key'] = mtfgf_get_css_generator_options_key();

$GLOBALS['mtfgf_css_generator_option'] = get_option( 'mtfgf_tooltip_generator' );

function mtfgf_fix_generator_option(&$obj, $key, $defaultKey ) { 
	if(!(isset($obj[$key]) && $obj[$key])) {
		$obj[$key] = $obj[$defaultKey];
	}
}


mtfgf_fix_generator_option($GLOBALS['mtfgf_css_generator_option'], 'css_code_pad', 'css_code');
mtfgf_fix_generator_option($GLOBALS['mtfgf_css_generator_option'], 'css_code_phone', 'css_code');

mtfgf_fix_generator_option($GLOBALS['mtfgf_css_generator_option'], 'css_options_pad', 'css_options');
mtfgf_fix_generator_option($GLOBALS['mtfgf_css_generator_option'], 'css_options_phone', 'css_options');

mtfgf_fix_generator_option($GLOBALS['mtfgf_css_generator_option'], 'js_code_pad', 'js_code');
mtfgf_fix_generator_option($GLOBALS['mtfgf_css_generator_option'], 'js_code_phone', 'js_code');

// print_r($GLOBALS['mtfgf_css_generator_option']);
// die();

// echo $GLOBALS['mtfgf_css_generator_options_key'];
// die();

function mtfgf_tooltip_generator_add_admin_menu(  ) { 

	add_submenu_page( 
          'magic_tooltips_for_gravity_forms' 
        , 'Tooltip Style Generator' 
        , 'Tooltip Style Generator'
        , 'manage_options'
        , 'mtfgf_tooltip_generator'
        , 'mtfgf_tooltip_generator_page'
    );
//plugins_url( 'assets/img/icon-17.png', __FILE__ )
}

function mtfgf_tooltip_generator_before_save($options_tooltip_generator, $old_value) {
	$license_control = true;
	if($license_control) {
		$options = get_option( 'mtfgf_settings' );
		if(isset($options['license_key']) && $options['license_key']) {
			$is_valid_license = mtfgf_check_license($options['license_key'], true);
			if($options['is_valid_license_key'] != $is_valid_license) {
				$options['is_valid_license_key'] = $is_valid_license;
				update_option('mtfgf_settings', $options);
			}
		}
	}
	return $options_tooltip_generator;
}


function mtfgf_tooltip_generator_init(  ) { 

	register_setting( 'mtfgf_tooltip_generator', 'mtfgf_tooltip_generator' );

	// echo $GLOBALS['mtfgf_css_generator_options_key'];
	// die();
	add_filter( 'pre_update_option_mtfgf_tooltip_generator', 'mtfgf_tooltip_generator_before_save', 10, 2 );

	add_settings_section(
		'mtfgf_tooltip_generator_section', 
		__( 'Your section description', 'magic_tooltips_for_gravity_forms' ), 
		'mtfgf_tooltip_generator_section_callback', 
		'mtfgf_tooltip_generator'
	);

	$settings_fields_key = array('', '_pad', '_phone');
	for($i =0; $i < 3; $i++) {
		add_settings_field( 
			'css_code'.$settings_fields_key[$i], 
			__( 'Css Code'.$settings_fields_key[$i], 'magic_tooltips_for_gravity_forms' ), 
			'mtfgf_tooltip_generator_css_code'.$settings_fields_key[$i].'_render', 
			'mtfgf_tooltip_generator', 
			'mtfgf_tooltip_generator_section' 
		);

		add_settings_field( 
			'css_options'.$settings_fields_key[$i], 
			__( 'Css Options'.$settings_fields_key[$i], 'magic_tooltips_for_gravity_forms' ), 
			'mtfgf_tooltip_generator_css_options'.$settings_fields_key[$i].'_render', 
			'mtfgf_tooltip_generator', 
			'mtfgf_tooltip_generator_section' 
		);

		add_settings_field( 
			'js_code'.$settings_fields_key[$i], 
			__( 'Js Code'.$settings_fields_key[$i], 'magic_tooltips_for_gravity_forms' ), 
			'mtfgf_tooltip_generator_js_code'.$settings_fields_key[$i].'_render', 
			'mtfgf_tooltip_generator', 
			'mtfgf_tooltip_generator_section' 
		);
	}

	
}


function mtfgf_tooltip_generator_css_code_render() { 
	$options = $GLOBALS['mtfgf_css_generator_option'];
	?>
	<input id="mtfgf-tooltip-generator-css-code" type='text' name='mtfgf_tooltip_generator[css_code]' value='<?php echo $options['css_code']; ?>'>
	<?php

}

function mtfgf_tooltip_generator_css_options_render() { 
	$options = $GLOBALS['mtfgf_css_generator_option'];
	?>
	<input id="mtfgf-tooltip-generator-css-options" type='text' name='mtfgf_tooltip_generator[css_options]' value='<?php echo $options['css_options']; ?>'>
	<?php

}

function mtfgf_tooltip_generator_js_code_render() { 
	$options = $GLOBALS['mtfgf_css_generator_option'];
	?>
	<input id="mtfgf-tooltip-generator-js-code" type='text' name='mtfgf_tooltip_generator[js_code]' value='<?php echo $options['js_code']; ?>'>
	<?php
}

/**
 * Pad
 * @return [type] [description]
 */
function mtfgf_tooltip_generator_css_code_pad_render() { 
	$options = $GLOBALS['mtfgf_css_generator_option'];
	?>
	<input id="mtfgf-tooltip-generator-css-code-pad" type='text' name='mtfgf_tooltip_generator[css_code_pad]' value='<?php echo $options['css_code_pad']; ?>'>
	<?php

}

function mtfgf_tooltip_generator_css_options_pad_render() { 
	$options = $GLOBALS['mtfgf_css_generator_option'];
	?>
	<input id="mtfgf-tooltip-generator-css-options-pad" type='text' name='mtfgf_tooltip_generator[css_options_pad]' value='<?php echo $options['css_options_pad']; ?>'>
	<?php

}

function mtfgf_tooltip_generator_js_code_pad_render() { 
	$options = $GLOBALS['mtfgf_css_generator_option'];
	?>
	<input id="mtfgf-tooltip-generator-js-code-pad" type='text' name='mtfgf_tooltip_generator[js_code_pad]' value='<?php echo $options['js_code_pad']; ?>'>
	<?php
}

/**
 * Mobile
 * @return [type] [description]
 */
function mtfgf_tooltip_generator_css_code_phone_render() { 
	$options = $GLOBALS['mtfgf_css_generator_option'];
	?>
	<input id="mtfgf-tooltip-generator-css-code-phone" type='text' name='mtfgf_tooltip_generator[css_code_phone]' value='<?php echo $options['css_code_phone']; ?>'>
	<?php

}

function mtfgf_tooltip_generator_css_options_phone_render() { 
	$options = $GLOBALS['mtfgf_css_generator_option'];
	?>
	<input id="mtfgf-tooltip-generator-css-options-phone" type='text' name='mtfgf_tooltip_generator[css_options_phone]' value='<?php echo $options['css_options_phone']; ?>'>
	<?php

}

function mtfgf_tooltip_generator_js_code_phone_render() { 
	$options = $GLOBALS['mtfgf_css_generator_option'];
	?>
	<input id="mtfgf-tooltip-generator-js-code-phone" type='text' name='mtfgf_tooltip_generator[js_code_phone]' value='<?php echo $options['js_code_phone']; ?>'>
	<?php
}

function mtfgf_tooltip_generator_section_callback(  ) { 
	echo __( 'Use this tool to generate your custom tooltip style. You can generate css for desktop, pad and phone seperately to get responsive support.', 'magic_tooltips_for_gravity_forms' );
}


function mtfgf_selected($device) {
	$selected  = ' selected="selected"';
	if(!isset($_GET['mtfgf_device'])) {
		return $device == 'pc' ? $selected : '';
	}
	else {
		return $device == $_GET['mtfgf_device'] ? $selected : '';
	}
}

function mtfgf_get_css_generator_options_key() {
	$device = (!isset($_GET['mtfgf_device'])) ? 'pc' : $_GET['mtfgf_device'];

	switch ($device) {
		
		case 'pad':
			return '-pad';
			break;
		case 'phone':
			return '-phone';
			break;
		case 'pc':
		default:
			return '';
			break;
	}
}

function mtfgf_tooltip_generator_page(  ) { 
	?>
	<form action='options.php' id="mtfgf-tooltip-generator-form" method='post'>
		<h1>Tooltip Style Generator</h1>
		<style>
			#mtfgf-tooltip-generator-form .form-table {
				display: none;
			}

			#mtfgf-tooltip-generator-form .form-table input {
				width: 100%;
			}
		</style>
		<div class="mtfgf-tooltip-generator-form-box">
		<?php
		settings_fields( 'mtfgf_tooltip_generator' );
		do_settings_sections( 'mtfgf_tooltip_generator' );
		?>
		</div>
		<div class="text">
	      <h2 style="display: block;">Choose a Device</h2>
	      <div class="inline-container">
	          <select id="mtfgf-device-picker" opt-key="<?php echo mtfgf_get_css_generator_options_key(); ?>" class="form-control">
	            <option value="pc" <?php echo mtfgf_selected('pc'); ?>>Desktop</option>
	            <option value="pad" <?php echo mtfgf_selected('pad'); ?>>Pad and Tablet</option>
	            <option value="phone" <?php echo mtfgf_selected('phone'); ?>>Mobile Phone</option>
	          </select>
	          <script type="text/javascript">
			    (function($){
			    	$('#mtfgf-device-picker').change(function () {
				        location.href = '<?php echo admin_url('admin.php?page=mtfgf_tooltip_generator');?>'+'&mtfgf_device='+$(this).val();
				    })
			    })(jQuery);    
			</script>
	      </div>
	    </div>
		<iframe id="mtfgf-tooltip-generator-iframe" src="<?php echo plugins_url('/magic-tooltips-for-gravity-forms/assets/tooltip-style-generator/index.html?ver='.MTFGF_VER) ?>" align="middle" width="95%" height="460" style="overflow:hidden" frameborder="0"></iframe>
		
		<p class="submit">
		<?php submit_button(null, 'primary', 'submit', false); ?>
		<input type="button" value="Reset" class="button button-info" id="reset-css" name="reset"></p>
	</form>
	<?php

}

?>